#pragma once
//#include "afx.h"
#include "extapi_defines.h"

// app function handle defs

typedef FARPROC (__stdcall* LPFNAPI_app_GetFuncHandle)(LPVOID hID, LPCSTR lpFuncHandle);
typedef void (__stdcall* LPFNAPI_app_ReportError)(LPVOID hID, LPCSTR lpErrorStr);

// var function handle defs

typedef ZVAR (__stdcall* LPFNAPI_var_Create)(LPVOID hID, long VarID, LPCSTR lpVarName);
typedef ZVAR (__stdcall* LPFNAPI_var_CreateTemp)(LPVOID hID, long VarID);
typedef bool (__stdcall* LPFNAPI_var_Delete)(LPVOID hID, ZVAR hVar);
typedef bool (__stdcall* LPFNAPI_var_Rename)(LPVOID hID, ZVAR hVar, LPCSTR lpNewName);
typedef ZVAR (__stdcall* LPFNAPI_var_GetVar)(LPVOID hID, LPCSTR lpVarName);
typedef LPCSTR (__stdcall* LPFNAPI_var_GetName)(LPVOID hID, ZVAR hVar);
typedef long (__stdcall* LPFNAPI_var_GetTypeID)(LPVOID hID, ZVAR hVar);
typedef bool (__stdcall* LPFNAPI_var_IsType)(LPVOID hID, ZVAR hVar, long VarID);
typedef bool (__stdcall* LPFNAPI_var_GetValue)(LPVOID hID, ZVAR hVar, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_SetValue)(LPVOID hID, ZVAR hVar, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_GetValueEx)(LPVOID hID, ZVAR hVar, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_SetValueEx)(LPVOID hID, ZVAR hVar, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_CopyValue)(LPVOID hID, ZVAR hVarDest, ZVAR hVarSrc);
typedef bool (__stdcall* LPFNAPI_var_SetVarRef)(LPVOID hID, ZVAR hPtrVar, ZVAR hSrcVar);
typedef bool (__stdcall* LPFNAPI_var_EditUI)(LPVOID hID, ZVAR hVar, LPCSTR lpPrompt);

// type function handle defs

typedef long (__stdcall* LPFNAPI_type_GetTypeID)(LPVOID hID, LPCSTR lpTypeName);
typedef bool (__stdcall* LPFNAPI_type_GetTypeName)(LPVOID hID, long VarID, ZVAR hStringVar);

// string function handle defs

typedef LPCSTR (__stdcall* LPFNAPI_str_GetText)(LPVOID hID, ZVAR hStr);
typedef bool (__stdcall* LPFNAPI_str_SetText)(LPVOID hID, ZVAR hStr, LPCSTR lpText);

// list function handle defs

typedef long (__stdcall* LPFNAPI_list_nItems)(LPVOID hID, ZLIST hList);
typedef ZVAR (__stdcall* LPFNAPI_list_CreateItem)(LPVOID hID, ZLIST hList, long VarID, LPCSTR lpVarName);
typedef ZVAR (__stdcall* LPFNAPI_list_GetItemI)(LPVOID hID, ZLIST hList, long index);
typedef ZVAR (__stdcall* LPFNAPI_list_GetItemA)(LPVOID hID, ZLIST hList, LPCSTR lpVarName);
typedef bool (__stdcall* LPFNAPI_list_DelItemI)(LPVOID hID, ZLIST hList, long index);
typedef bool (__stdcall* LPFNAPI_list_DelItemA)(LPVOID hID, ZLIST hList, LPCSTR lpVarName);
typedef bool (__stdcall* LPFNAPI_list_DelAll)(LPVOID hID, ZLIST hList);

// map function handle defs

typedef bool (__stdcall* LPFNAPI_map_Init)(LPVOID hID, ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag);
typedef bool (__stdcall* LPFNAPI_map_Free)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetPixelSize)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetWrapFlag)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SetWrapFlag)(LPVOID hID, ZMAP hMap, bool WrapFlag);
typedef bool (__stdcall* LPFNAPI_map_GetBusyFlag)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SetBusyFlag)(LPVOID hID, ZMAP hMap, bool BusyFlag);
typedef long (__stdcall* LPFNAPI_map_GetMapType)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetWidth)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetHeight)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetPixel)(LPVOID hID, ZMAP hMap, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_map_SetPixel)(LPVOID hID, ZMAP hMap, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_map_GetMinMaxAlt)(LPVOID hID, ZMAP hMap, float& minval, float& maxval);
typedef bool (__stdcall* LPFNAPI_map_SetMinMaxAlt)(LPVOID hID, ZMAP hMap, float& minval, float& maxval);
typedef float (__stdcall* LPFNAPI_map_GetHorizScale)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetMosaicFlag)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTileSize)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTilesX)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTilesY)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetFlag)(LPVOID hID, ZMAP hMap, long FlagID);
typedef bool (__stdcall* LPFNAPI_map_SetFlag)(LPVOID hID, ZMAP hMap, long FlagID, bool FlagValue);
typedef ZLIST (__stdcall* LPFNAPI_map_GetSettingsList)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SaveFile)(LPVOID hID, ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
typedef bool (__stdcall* LPFNAPI_map_LoadFile)(LPVOID hID, ZMAP hMap, LPCSTR lpFileName, long MapTypeID, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
typedef bool (__stdcall* LPFNAPI_map_GetNameInProject)(LPVOID hID, ZMAP hMap, ZVAR hStr);
typedef bool (__stdcall* LPFNAPI_map_InitMosaic)(LPVOID hID, ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag, LPCSTR lpMosaicFileName, long TileSize, ZFORMAT hFormat, LPCSTR lpProjMapName);
typedef bool (__stdcall* LPFNAPI_map_LoadMosaic)(LPVOID hID, ZMAP hMap, LPCSTR lpMosaicFileName);
typedef bool (__stdcall* LPFNAPI_map_SaveMosaic)(LPVOID hID, ZMAP hMap);
typedef ZFORMAT (__stdcall* LPFNAPI_map_GetFormat)(LPVOID hID, ZMAP hMap);
typedef bool  (__stdcall* LPFNAPI_map_SetFormat)(LPVOID hID, ZMAP hMap, ZFORMAT hFormat);
typedef LPCSTR (__stdcall* LPFNAPI_map_GetFilename)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_CombineMosaic)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SplitToMosaic)(LPVOID hID, ZMAP hMap, LPCSTR lpMosaicFileName, long TileSize, ZFORMAT hFormat, LPCSTR lpProjMapName);
typedef bool (__stdcall* LPFNAPI_map_SaveMosaicAs)(LPVOID hID, ZMAP hMap, LPCSTR lpFileName);
typedef bool (__stdcall* LPFNAPI_map_ExportMap)(LPVOID hID, ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, long nx, long ny);
typedef bool (__stdcall* LPFNAPI_map_ExportMosaic)(LPVOID hID, ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, long nx, long ny, long TileSize, LPCSTR lpProjMapName);

// mosaic tile function defs

typedef bool (__stdcall* LPFNAPI_tile_GetMinMaxAlt)(LPVOID hID, LPVOID hTile, float& minval, float& maxval);
typedef bool (__stdcall* LPFNAPI_tile_GetPixel)(LPVOID hID, LPVOID hTile, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_tile_SetPixel)(LPVOID hID, LPVOID hTile, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_tile_GetTileCoords)(LPVOID hID, LPVOID hTile, long& x, long& y);

// format function handle defs

typedef ZFORMAT (__stdcall* LPFNAPI_format_Create)(LPVOID hID, LPCSTR lpMapName, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
typedef ZFORMAT (__stdcall* LPFNAPI_format_CreateGeneric)(LPVOID hID, long MapTypeID, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
typedef bool (__stdcall* LPFNAPI_format_SetFlags)(LPVOID hID, ZFORMAT hFormat, bool Native, bool Mosaic);
typedef bool (__stdcall* LPFNAPI_format_SetInfoStr)(LPVOID hID, ZFORMAT hFormat, LPCSTR lpInfoStr);
typedef LPCSTR (__stdcall* LPFNAPI_format_GetExt)(LPVOID hID, ZFORMAT hFormat);
typedef ZLIST (__stdcall* LPFNAPI_format_GetOptionList)(LPVOID hID, ZFORMAT hFormat);
typedef bool (__stdcall* LPFNAPI_format_GetOptionValue)(LPVOID hID, ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_format_SetOptionValue)(LPVOID hID, ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);
typedef ZFORMAT (__stdcall* LPFNAPI_format_GetFormatByExt)(LPVOID hID, LPCSTR lpMapName, long MapTypeID, LPCSTR lpFileExt);
typedef ZLIST (__stdcall* LPFNAPI_format_GetFormatList)(LPVOID hID, LPCSTR lpMapName, long MapTypeID);
typedef bool (__stdcall* LPFNAPI_format_IsMosaic)(LPVOID hID, ZFORMAT hFormat);
typedef bool (__stdcall* LPFNAPI_format_IsNative)(LPVOID hID, ZFORMAT hFormat);


// prog box function handle defs

typedef bool (__stdcall* LPFNAPI_progbox_ShowWnd)(LPVOID hID, ZVAR hProgWnd);
typedef bool (__stdcall* LPFNAPI_progbox_HideWnd)(LPVOID hID, ZVAR hProgWnd);
typedef bool (__stdcall* LPFNAPI_progbox_SetTitle)(LPVOID hID, ZVAR hProgWnd, LPCSTR lpTitleText);
typedef bool (__stdcall* LPFNAPI_progbox_SetProgress)(LPVOID hID, ZVAR hProgWnd, __int64 p, __int64 pmax);

// combo box function handle defs

typedef bool (__stdcall* LPFNAPI_combosel_SetOptions)(LPVOID hID, ZVAR hComboSel, LPCSTR lpOptionsStr);
typedef LPCSTR (__stdcall* LPFNAPI_combosel_GetOptions)(LPVOID hID, ZVAR hComboSel);
typedef bool (__stdcall* LPFNAPI_combosel_SetCurSel)(LPVOID hID, ZVAR hComboSel, LPCSTR lpCurSelStr);
typedef LPCSTR (__stdcall* LPFNAPI_combosel_GetCurSel)(LPVOID hID, ZVAR hComboSel);

// buffer function handle defs

typedef bool (__stdcall* LPFNAPI_buffer_Init)(LPVOID hID, ZVAR hBuf, long nItems, long ItemSize);
typedef bool (__stdcall* LPFNAPI_buffer_Free)(LPVOID hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_nItems)(LPVOID hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_MemSize)(LPVOID hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_ItemSize)(LPVOID hID, ZVAR hBuf);
typedef LPVOID (__stdcall* LPFNAPI_buffer_GetPtr)(LPVOID hID, ZVAR hBuf);
typedef bool (__stdcall* LPFNAPI_buffer_GetValue)(LPVOID hID, ZVAR hBuf, long index, void* pValue);
typedef bool (__stdcall* LPFNAPI_buffer_SetValue)(LPVOID hID, ZVAR hBuf, long index, void* pValue);

// project function handle defs

typedef bool (__stdcall* LPFNAPI_project_GetHeightfieldRange)(LPVOID hID, float& minval, float& maxval);
typedef ZMAP (__stdcall* LPFNAPI_project_GetMap)(LPVOID hID, LPCSTR lpMapName);
typedef LPCSTR (__stdcall* LPFNAPI_project_GetProjectFilename)(LPVOID hID);
typedef bool (__stdcall* LPFNAPI_project_GetSettingsList)(LPVOID hID, ZLIST hSettingsList);

// view function handle defs

typedef bool (__stdcall* LPFNAPI_view_ShowMap)(LPVOID hID, LPCSTR lpProjMapName);
typedef ZMAP (__stdcall* LPFNAPI_view_GetActiveMap)(LPVOID hID);
typedef bool (__stdcall* LPFNAPI_view_GetSelectedArea)(LPVOID hID, ZLIST hCoordsList);

// calculation functions

typedef COLORREF (__stdcall* LPFNAPI_calc_AM_GetPixelColour)(LPVOID hID, AttributesPixel AMpxl);
typedef AttributesPixel (__stdcall* LPFNAPI_calc_AM_GetIDfromColour)(LPVOID hID, COLORREF col);

// file/dir functions

typedef bool (__stdcall* LPFNAPI_file_GetExt)(LPVOID hID, ZVAR hStr, LPCSTR lpFileName);
typedef bool (__stdcall* LPFNAPI_file_GetFilenameNoExt)(LPVOID hID, ZVAR hStr, LPCSTR lpFileName);
typedef bool (__stdcall* LPFNAPI_file_GetDir)(LPVOID hID, ZVAR hStr, LPCSTR lpFileName);
typedef bool (__stdcall* LPFNAPI_file_GetFilenameNoDir)(LPVOID hID, ZVAR hStr, LPCSTR lpFileName);
typedef bool (__stdcall* LPFNAPI_file_FileExists)(LPVOID hID, LPCSTR lpFileName);

// extension functions

typedef ZVAR (__stdcall* LPFNAPI_zeofunc_LoadFunc)(LPVOID hID, LPCSTR lpFnName, long rvalVarID, ZLIST hArgList);
typedef ZVAR (__stdcall* LPFNAPI_zeofunc_LoadFuncEx)(LPVOID hID, LPCSTR lpFnName, LPCSTR lpExportName, long rvalVarID, ZLIST hArgList);
typedef ZVAR (__stdcall* LPFNAPI_zeofunc_GetFunc)(LPVOID hID, LPCSTR lpFnName);
typedef long (__stdcall* LPFNAPI_zeofunc_GetReturnTypeID)(LPVOID hID, ZFUNC hFunc);
typedef bool (__stdcall* LPFNAPI_zeofunc_GetArgListPrototype)(LPVOID hID,  ZFUNC hFunc, ZLIST hArgList);
typedef ZVAR (__stdcall* LPFNAPI_zeofunc_Execute)(LPVOID hID, ZFUNC hFunc, ZLIST hArgList);

// menu functions

typedef bool (__stdcall* LPFNAPI_menu_InsertItem)(LPVOID hID, LPCSTR lpFnName, LPCSTR lpOptionName);




// function for reporting API version to calling app

extern "C" __declspec( dllexport ) LPCSTR __stdcall ExtGetApiVersion(void);


class CExtAPI :
	public CObject
{
public:
	CExtAPI(void);
	~CExtAPI(void);

	bool InitAPI(FARPROC pFunc, LPVOID hID);

	// app functions

	void	ReportError(LPCSTR lpErrorMessage);

	// var functions

	ZVAR	var_Create(long VarID, LPCSTR lpVarName);
	ZVAR	var_CreateTemp(long VarID);
	bool	var_Delete(ZVAR hVar);
	bool	var_Rename(ZVAR hVar, LPCSTR lpNewName);
	ZVAR	var_GetVar(LPCSTR lpVarName);
	LPCSTR	var_GetName(ZVAR hVar);
	long	var_GetTypeID(ZVAR hVar);
	bool	var_IsType(ZVAR hVar, long VarID);
	bool	var_GetValue(ZVAR hVar, void* pValue);
	bool	var_SetValue(ZVAR hVar, void* pValue);
	bool	var_GetValueEx(ZVAR hVar, long VarID, void* pValue);
	bool	var_SetValueEx(ZVAR hVar, long VarID, void* pValue);
	bool	var_CopyValue(ZVAR hVarDest, ZVAR hVarSrc);
	bool	var_SetVarRef(ZVAR hPtrVar, ZVAR hSrcVar);
	bool	var_EditUI(ZVAR hVar, LPCSTR lpPrompt);

	// type functions

	long	type_GetTypeID(LPCSTR lpTypeName);
	bool	type_GetTypeName(long VarID, ZVAR hStringVar);

	// string functions

	LPCSTR	str_GetText(ZVAR hStr);
	bool	str_SetText(ZVAR hStr, LPCSTR lpText);

	// list functions

	long	list_nItems(ZLIST hList);
	ZLIST	list_CreateItem(ZLIST hList, long VarID, LPCSTR lpVarName);
	ZLIST	list_GetItemI(ZLIST hList, long index);
	ZLIST	list_GetItemA(ZLIST hList, LPCSTR lpVarName);
	bool	list_DelItemI(ZLIST hList, long index);
	bool	list_DelItemA(ZLIST hList, LPCSTR lpVarName);
	bool	list_DelAll(ZLIST hList);

	// map functions

	bool	map_Init(ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag);
	bool	map_Free(ZMAP hMap);
	long	map_GetMapType(ZMAP hMap);
	long	map_GetPixelSize(ZMAP hMap);
	bool	map_GetWrapFlag(ZMAP hMap);
	bool	map_SetWrapFlag(ZMAP hMap, bool WrapFlag);
	bool	map_GetBusyFlag(ZMAP hMap);
	bool	map_SetBusyFlag(ZMAP hMap, bool BusyFlag);
	long	map_GetWidth(ZMAP hMap);
	long	map_GetHeight(ZMAP hMap);
	bool	map_GetPixel(ZMAP hMap, long x, long y, void* pValue);
	bool	map_SetPixel(ZMAP hMap, long x, long y, void* pValue);
	bool	map_GetMinMaxAlt(ZMAP hMap, float& minval, float& maxval);
	bool	map_SetMinMaxAlt(ZMAP hMap, float& minval, float& maxval);
	float	map_GetHorizScale(ZMAP hMap);
	bool	map_GetMosaicFlag(ZMAP hMap);
	long	map_GetMosaicTileSize(ZMAP hMap);
	long	map_GetMosaicTilesX(ZMAP hMap);
	long	map_GetMosaicTilesY(ZMAP hMap);
	bool	map_GetFlag(ZMAP hMap, long FlagID);
	bool	map_SetFlag(ZMAP hMap, long FlagID, bool FlagValue);
	ZLIST	map_GetSettingsList(ZMAP hMap);
	bool	map_SaveFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
	bool	map_LoadFile(ZMAP hMap, LPCSTR lpFileName, long MapTypeID, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
	bool	map_GetNameInProject(ZMAP hMap, ZVAR hStr);
	bool	map_InitMosaic(ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag, LPCSTR lpMosaicFileName, long TileSize, ZFORMAT hFormat, LPCSTR lpProjMapName);
	bool	map_LoadMosaic(ZMAP hMap, LPCSTR lpMosaicFileName);
	bool	map_SaveMosaic(ZMAP hMap);
	ZFORMAT map_GetFormat(ZMAP hMap);
	bool	map_SetFormat(ZMAP hMap, ZFORMAT hFormat);
	LPCSTR	map_GetFilename(ZMAP hMap);
	bool	map_CombineMosaic(ZMAP hMap);
	bool	map_SplitToMosaic(ZMAP hMap, LPCSTR lpMosaicFileName, long TileSize, ZFORMAT hFormat, LPCSTR lpProjMapName);
	bool	map_SaveMosaicAs(ZMAP hMap, LPCSTR lpFileName);
	bool	map_ExportMap(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, long nx, long ny);
	bool	map_ExportMosaic(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, long nx, long ny, long TileSize, LPCSTR lpProjMapName);

	// mosaic tile functions

	bool	tile_GetMinMaxAlt(LPVOID hTile, float& minval, float& maxval);
	bool	tile_GetPixel(LPVOID hTile, long x, long y, void* pValue);
	bool	tile_SetPixel(LPVOID hTile, long x, long y, void* pValue);
	bool	tile_GetTileCoords(LPVOID hTile, long& x, long& y);

	//format functions

	ZFORMAT format_Create(LPCSTR lpMapName, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
	ZFORMAT format_CreateGeneric(long MapTypeID, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
	bool	format_SetFlags(ZFORMAT hFormat, bool Native, bool Mosaic);
	bool	format_SetInfoStr(ZFORMAT hFormat, LPCSTR lpInfoStr);
	LPCSTR	format_GetExt(ZFORMAT hFormat);
	ZLIST	format_GetOptionList(ZFORMAT hFormat);
	bool	format_GetOptionValue(ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);
	bool	format_SetOptionValue(ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);
	ZFORMAT	format_GetFormatByExt(LPCSTR lpMapName, long MapTypeID, LPCSTR lpFileExt);
	ZFORMAT format_GetFormatByExt2(ZMAP hMap, LPCSTR lpFileExt);
	ZLIST	format_GetFormatList(LPCSTR lpMapName, long MapTypeID);
	ZLIST	format_GetFormatList2(ZMAP hMap);
	bool	format_IsMosaic(ZFORMAT hFormat);
	bool	format_IsNative(ZFORMAT hFormat);

	// prog box functions

	bool progbox_ShowWnd(ZVAR hProgWnd);
	bool progbox_HideWnd(ZVAR hProgWnd);
	bool progbox_SetTitle(ZVAR hProgWnd, LPCSTR lpTitleText);
	bool progbox_SetProgress(ZVAR hProgWnd, __int64 p, __int64 pmax);

	// combo box functions

	bool	combosel_SetOptions(ZVAR hComboSel, LPCSTR lpOptionsStr);
	LPCSTR	combosel_GetOptions(ZVAR hComboSel);
	bool	combosel_SetCurSel(ZVAR hComboSel, LPCSTR lpCurSelStr);
	LPCSTR	combosel_GetCurSel(ZVAR hComboSel);

	// project functions

	bool	project_GetHeightfieldRange(float& minval, float& maxval);
	ZMAP	project_GetMap(LPCSTR lpMapName);
	LPCSTR	project_GetProjectFilename();
	bool	project_GetSettingsList(ZLIST hSettingsList);

	// view functions

	bool	view_ShowMap(LPCSTR lpProjMapName);
	ZMAP	view_GetActiveMap();
	bool	view_GetSelectedArea(ZLIST hCoordsList);

	// calculation functions

	COLORREF		calc_AM_GetPixelColour(AttributesPixel AMpxl);
	AttributesPixel calc_AM_GetIDfromColour(COLORREF col);

	// file/dir functions

	bool	file_GetExt(ZVAR hStr, LPCSTR lpFileName);
	bool	file_GetFilenameNoExt(ZVAR hStr, LPCSTR lpFileName);
	bool	file_GetDir(ZVAR hStr, LPCSTR lpFileName);
	bool	file_GetFilenameNoDir(ZVAR hStr, LPCSTR lpFileName);
	bool	file_FileExists(LPCSTR lpFileName);

	// buffer function handle defs

	bool	buffer_Init(ZVAR hBuf, long nItems, long ItemSize);
	bool	buffer_Free(ZVAR hBuf);
	long	buffer_nItems(ZVAR hBuf);
	long	buffer_MemSize(ZVAR hBuf);
	long	buffer_ItemSize(ZVAR hBuf);
	LPVOID	buffer_GetPtr(ZVAR hBuf);
	bool	buffer_GetValue(ZVAR hBuf, long index, void* pValue);
	bool	buffer_SetValue(ZVAR hBuf, long index, void* pValue);

	// extension functions

	ZVAR	zeofunc_LoadFunc(LPCSTR lpFnName, long rvalVarID, ZLIST hArgList);
	ZVAR	zeofunc_LoadFuncEx(LPCSTR lpFnName, LPCSTR lpExportName, long rvalVarID, ZLIST hArgList);
	ZVAR	zeofunc_GetFunc(LPCSTR lpFnName);
	long	zeofunc_GetReturnTypeID(ZFUNC hFunc);
	bool	zeofunc_GetArgListPrototype(ZFUNC hFunc, ZLIST hArgList);
	ZVAR	zeofunc_Execute(ZFUNC hFunc, ZLIST hArgList);

	// menu functions
	bool	menu_InsertItem(LPCSTR lpFnName, LPCSTR lpOptionName);

protected:

	// bootstrapping function

	FARPROC GetFuncHandle(LPCSTR lpFuncName);

	// session ID's

	LPVOID m_hID;

	// app function handles

	LPFNAPI_app_GetFuncHandle	m_lpfnGetFuncHandle;
	LPFNAPI_app_ReportError		m_lpfnReportError;

	// var function handles

	LPFNAPI_var_Create			m_lpfn_var_Create;
	LPFNAPI_var_CreateTemp		m_lpfn_var_CreateTemp;
	LPFNAPI_var_Delete			m_lpfn_var_Delete;
	LPFNAPI_var_Rename			m_lpfn_var_Rename;
	LPFNAPI_var_GetVar			m_lpfn_var_GetVar;
	LPFNAPI_var_GetName			m_lpfn_var_GetName;
	LPFNAPI_var_GetTypeID		m_lpfn_var_GetTypeID;
	LPFNAPI_var_IsType			m_lpfn_var_IsType;
	LPFNAPI_var_GetValue		m_lpfn_var_GetValue;
	LPFNAPI_var_SetValue		m_lpfn_var_SetValue;
	LPFNAPI_var_GetValueEx		m_lpfn_var_GetValueEx;
	LPFNAPI_var_SetValueEx		m_lpfn_var_SetValueEx;
	LPFNAPI_var_CopyValue		m_lpfn_var_CopyValue;
	LPFNAPI_var_SetVarRef		m_lpfn_var_SetVarRef;
	LPFNAPI_var_EditUI			m_lpfn_var_EditUI;

	// type function handles

	LPFNAPI_type_GetTypeID		m_lpfn_type_GetTypeID;
	LPFNAPI_type_GetTypeName	m_lpfn_type_GetTypeName;

	// string function handles

	LPFNAPI_str_GetText			m_lpfn_str_GetText;
	LPFNAPI_str_SetText			m_lpfn_str_SetText;

	// list function handles

	LPFNAPI_list_nItems			m_lpfn_list_nItems;
	LPFNAPI_list_CreateItem		m_lpfn_list_CreateItem;
	LPFNAPI_list_GetItemI		m_lpfn_list_GetItemI;
	LPFNAPI_list_GetItemA		m_lpfn_list_GetItemA;
	LPFNAPI_list_DelItemI		m_lpfn_list_DelItemI;
	LPFNAPI_list_DelItemA		m_lpfn_list_DelItemA;
	LPFNAPI_list_DelAll			m_lpfn_list_DelAll;

	// map function handles

	LPFNAPI_map_Init			m_lpfn_map_Init;
	LPFNAPI_map_Free			m_lpfn_map_Free;
	LPFNAPI_map_GetMapType		m_lpfn_map_GetMapType;
	LPFNAPI_map_GetPixelSize	m_lpfn_map_GetPixelSize;
	LPFNAPI_map_GetWrapFlag		m_lpfn_map_GetWrapFlag;
	LPFNAPI_map_SetWrapFlag		m_lpfn_map_SetWrapFlag;
	LPFNAPI_map_GetBusyFlag		m_lpfn_map_GetBusyFlag;
	LPFNAPI_map_SetBusyFlag		m_lpfn_map_SetBusyFlag;
	LPFNAPI_map_GetWidth		m_lpfn_map_GetWidth;
	LPFNAPI_map_GetHeight		m_lpfn_map_GetHeight;
	LPFNAPI_map_GetPixel		m_lpfn_map_GetPixel;
	LPFNAPI_map_SetPixel		m_lpfn_map_SetPixel;
	LPFNAPI_map_GetMinMaxAlt	m_lpfn_map_GetMinMaxAlt;
	LPFNAPI_map_SetMinMaxAlt	m_lpfn_map_SetMinMaxAlt;
	LPFNAPI_map_GetHorizScale	m_lpfn_map_GetHorizScale;
	LPFNAPI_map_GetMosaicFlag		m_lpfn_map_GetMosaicFlag;
	LPFNAPI_map_GetMosaicTileSize	m_lpfn_map_GetMosaicTileSize;
	LPFNAPI_map_GetMosaicTilesX		m_lpfn_map_GetMosaicTilesX;
	LPFNAPI_map_GetMosaicTilesY		m_lpfn_map_GetMosaicTilesY;
	LPFNAPI_map_GetFlag				m_lpfn_map_GetFlag;
	LPFNAPI_map_SetFlag				m_lpfn_map_SetFlag;
	LPFNAPI_map_GetSettingsList		m_lpfn_map_GetSettingsList;
	LPFNAPI_map_SaveFile			m_lpfn_map_SaveFile;
	LPFNAPI_map_LoadFile			m_lpfn_map_LoadFile;
	LPFNAPI_map_GetNameInProject	m_lpfn_map_GetNameInProject;
	LPFNAPI_map_InitMosaic			m_lpfn_map_InitMosaic;
	LPFNAPI_map_LoadMosaic			m_lpfn_map_LoadMosaic;
	LPFNAPI_map_SaveMosaic			m_lpfn_map_SaveMosaic;
	LPFNAPI_map_GetFormat			m_lpfn_map_GetFormat;
	LPFNAPI_map_SetFormat			m_lpfn_map_SetFormat;
	LPFNAPI_map_GetFilename			m_lpfn_map_GetFilename;
	LPFNAPI_map_CombineMosaic		m_lpfn_map_CombineMosaic;
	LPFNAPI_map_SplitToMosaic		m_lpfn_map_SplitToMosaic;
	LPFNAPI_map_SaveMosaicAs		m_lpfn_map_SaveMosaicAs;
	LPFNAPI_map_ExportMap			m_lpfn_map_ExportMap;
	LPFNAPI_map_ExportMosaic		m_lpfn_map_ExportMosaic;

	// mosaic tile function handles

	LPFNAPI_tile_GetMinMaxAlt	m_lpfn_tile_GetMinMaxAlt;
	LPFNAPI_tile_GetPixel		m_lpfn_tile_GetPixel;
	LPFNAPI_tile_SetPixel		m_lpfn_tile_SetPixel;
	LPFNAPI_tile_GetTileCoords	m_lpfn_tile_GetTileCoords;

	// format function handles

	LPFNAPI_format_Create			m_lpfn_format_Create;
	LPFNAPI_format_CreateGeneric	m_lpfn_format_CreateGeneric;
	LPFNAPI_format_SetFlags			m_lpfn_format_SetFlags;
	LPFNAPI_format_SetInfoStr		m_lpfn_format_SetInfoStr;
	LPFNAPI_format_GetExt			m_lpfn_format_GetExt;
	LPFNAPI_format_GetOptionList	m_lpfn_format_GetOptionList;
	LPFNAPI_format_GetOptionValue	m_lpfn_format_GetOptionValue;
	LPFNAPI_format_SetOptionValue	m_lpfn_format_SetOptionValue;
	LPFNAPI_format_GetFormatByExt	m_lpfn_format_GetFormatByExt;
	LPFNAPI_format_GetFormatList	m_lpfn_format_GetFormatList;
	LPFNAPI_format_IsMosaic			m_lpfn_format_IsMosaic;
	LPFNAPI_format_IsNative			m_lpfn_format_IsNative;

	// prog box function handles

	LPFNAPI_progbox_ShowWnd			m_lpfn_progbox_ShowWnd;
	LPFNAPI_progbox_HideWnd			m_lpfn_progbox_HideWnd;
	LPFNAPI_progbox_SetTitle		m_lpfn_progbox_SetTitle;
	LPFNAPI_progbox_SetProgress		m_lpfn_progbox_SetProgress;

	// combo box function handles

	LPFNAPI_combosel_SetOptions		m_lpfn_combosel_SetOptions;
	LPFNAPI_combosel_GetOptions		m_lpfn_combosel_GetOptions;
	LPFNAPI_combosel_SetCurSel		m_lpfn_combosel_SetCurSel;
	LPFNAPI_combosel_GetCurSel		m_lpfn_combosel_GetCurSel;

	// buffer function handles

	LPFNAPI_buffer_Init			m_lpfn_buffer_Init;
	LPFNAPI_buffer_Free			m_lpfn_buffer_Free;
	LPFNAPI_buffer_nItems		m_lpfn_buffer_nItems;
	LPFNAPI_buffer_MemSize		m_lpfn_buffer_MemSize;
	LPFNAPI_buffer_ItemSize		m_lpfn_buffer_ItemSize;
	LPFNAPI_buffer_GetPtr		m_lpfn_buffer_GetPtr;
	LPFNAPI_buffer_GetValue		m_lpfn_buffer_GetValue;
	LPFNAPI_buffer_SetValue		m_lpfn_buffer_SetValue;

	// project function handles

	LPFNAPI_project_GetHeightfieldRange		m_lpfn_project_GetHeightfieldRange;
	LPFNAPI_project_GetMap					m_lpfn_project_GetMap;
	LPFNAPI_project_GetProjectFilename		m_lpfn_project_GetProjectFilename;
	LPFNAPI_project_GetSettingsList			m_lpfn_project_GetSettingsList;

	// view function handles

	LPFNAPI_view_ShowMap					m_lpfn_view_ShowMap;
	LPFNAPI_view_GetActiveMap				m_lpfn_view_GetActiveMap;
	LPFNAPI_view_GetSelectedArea			m_lpfn_view_GetSelectedArea;

	// calculation function handles

	LPFNAPI_calc_AM_GetPixelColour			m_lpfn_calc_AM_GetPixelColour;
	LPFNAPI_calc_AM_GetIDfromColour			m_lpfn_calc_AM_GetIDfromColour;

	// file/dir function handles

	LPFNAPI_file_GetExt						m_lpfn_file_GetExt;
	LPFNAPI_file_GetFilenameNoExt			m_lpfn_file_GetFilenameNoExt;
	LPFNAPI_file_GetDir						m_lpfn_file_GetDir;
	LPFNAPI_file_GetFilenameNoDir			m_lpfn_file_GetFilenameNoDir;
	LPFNAPI_file_FileExists					m_lpfn_file_FileExists;

	// extension function handles

	LPFNAPI_zeofunc_LoadFunc				m_lpfn_zeofunc_LoadFunc;
	LPFNAPI_zeofunc_LoadFuncEx				m_lpfn_zeofunc_LoadFuncEx;
	LPFNAPI_zeofunc_GetFunc					m_lpfn_zeofunc_GetFunc;
	LPFNAPI_zeofunc_GetReturnTypeID			m_lpfn_zeofunc_GetReturnTypeID;
	LPFNAPI_zeofunc_GetArgListPrototype		m_lpfn_zeofunc_GetArgListPrototype;
	LPFNAPI_zeofunc_Execute					m_lpfn_zeofunc_Execute;

	//menu function handles

	LPFNAPI_menu_InsertItem					m_lpfn_menu_InsertItem;
};
