#include "zformat.h"
#include "extapi.h"
extern CExtAPI theAPI;

CzFormat::CzFormat(void) {
}

CzFormat::~CzFormat(void) {
}

bool CzFormat::Create(LPCSTR lpMapName, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName) {
	return Attach(theAPI.format_Create(lpMapName, lpLongName, lpFileExt, lpNativeProgramName));
}
bool CzFormat::CreateGeneric(long MapTypeID, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName) {
	return Attach(theAPI.format_CreateGeneric(MapTypeID, lpLongName, lpFileExt, lpNativeProgramName));
}
bool CzFormat::GetByExt(LPCSTR lpMapName, long MapTypeID, LPCSTR lpFileExt) {
	return Attach(theAPI.format_GetFormatByExt(lpMapName, MapTypeID, lpFileExt));
}
bool CzFormat::GetByExt2(ZMAP hMap, LPCSTR lpFileExt) {
	return Attach(theAPI.format_GetFormatByExt2(hMap, lpFileExt));
}
bool CzFormat::SetFlags(bool Native, bool Mosaic) {
	if(!IsType(VarID_format))	return false;

	return theAPI.format_SetFlags(m_hVar, Native, Mosaic);
}
bool CzFormat::SetInfoStr(LPCSTR lpInfoStr) {
	if(!IsType(VarID_format))	return false;

	return theAPI.format_SetInfoStr(m_hVar, lpInfoStr);
}
LPCSTR CzFormat::GetExt() {
	if(!IsType(VarID_format))	return NULL;

	return theAPI.format_GetExt(m_hVar);

}
ZLIST CzFormat::GetOptionList() {
	if(!IsType(VarID_format))	return NULL;

	return theAPI.format_GetOptionList(m_hVar);

}
bool CzFormat::GetOptionValue(LPCSTR lpOptionName, long VarID, void* pValue) {
	if(!IsType(VarID_format))	return false;

	return theAPI.format_GetOptionValue(m_hVar, lpOptionName, VarID, pValue);

}
bool CzFormat::SetOptionValue(LPCSTR lpOptionName, long VarID, void* pValue) {
	if(!IsType(VarID_format))	return false;

	return theAPI.format_SetOptionValue(m_hVar, lpOptionName, VarID, pValue);

}
bool CzFormat::IsMosaic() {
	if(!IsType(VarID_format))	return false;

	return theAPI.format_IsMosaic(m_hVar);

}
bool CzFormat::IsNative() {
	if(!IsType(VarID_format))	return false;

	return theAPI.format_IsNative(m_hVar);

}