#include "zfunc.h"
#include "ExtAPI.h"

extern CExtAPI theAPI;

CzFunc::CzFunc(void) {
}

CzFunc::~CzFunc(void) {
}

bool CzFunc::LoadFunc(LPCSTR lpFnName, long rvalVarID, ZLIST hArgList) {
	return Attach(theAPI.zeofunc_LoadFunc(lpFnName, rvalVarID, hArgList));
}
bool CzFunc::LoadFuncEx(LPCSTR lpFnName, LPCSTR lpExportName, long rvalVarID, ZLIST hArgList) {
	return Attach(theAPI.zeofunc_LoadFuncEx(lpFnName, lpExportName, rvalVarID, hArgList));
}
bool CzFunc::GetFunc(LPCSTR lpFnName) {
	return Attach(theAPI.zeofunc_GetFunc(lpFnName));
}
long CzFunc::GetReturnTypeID() {
	if(!m_hVar)	return 0;

	return theAPI.zeofunc_GetReturnTypeID(m_hVar);
}
bool CzFunc::GetArgListPrototype(ZLIST hArgList) {
	if(!m_hVar)	return false;

	return theAPI.zeofunc_GetArgListPrototype(m_hVar, hArgList);
}
ZVAR CzFunc::Execute(ZLIST hArgList) {
	if(!m_hVar)	return NULL;

	if(!hArgList)
			return theAPI.zeofunc_Execute(m_hVar, m_args.GetZVAR());
	else	return theAPI.zeofunc_Execute(m_hVar, hArgList);
}

bool CzFunc::Attach(ZVAR hVar) {
	if(!CzVar::Attach(hVar))	return false;

	if(!IsType(VarID_ZeoFunc)) {
		Delete();
		return false;
	}

	if(!GetArgListPrototype(m_args.GetZVAR())) {
		Delete();
		return false;
	}

	return true;
}