#include "zlist.h"

#include "extapi.h"
extern CExtAPI theAPI;


CzList::CzList() {
	Create(NULL);
}

CzList::~CzList(void) {
}

bool CzList::Create(LPCSTR lpVarName) {
	return CzVar::Create(VarID_varlist, lpVarName);
}

long CzList::nItems() {
	if(!m_hVar)	return 0;

	return theAPI.list_nItems(m_hVar);
}
ZVAR CzList::CreateItem(long VarID, LPCSTR lpVarName) {
	if(!m_hVar)	return NULL;

	return theAPI.list_CreateItem(m_hVar, VarID, lpVarName);
}
ZVAR CzList::GetOrCreateItem(long VarID, LPCSTR lpVarName) {
	if(!m_hVar)	return NULL;

	ZVAR TempVar = NULL;

	if(TempVar = GetItem(lpVarName)) {
		// var exists, now check type
		if(theAPI.var_IsType(TempVar, VarID))
				return TempVar;
		else	return false;
	}
	
	return CreateItem(VarID, lpVarName);
}
ZVAR CzList::GetItem(long index) {
	if(!m_hVar)	return NULL;

	return theAPI.list_GetItemI(m_hVar, index);
}
ZVAR CzList::GetItem(LPCSTR lpVarName) {
	if(!m_hVar)	return NULL;

	return theAPI.list_GetItemA(m_hVar, lpVarName);
}
bool CzList::DelItem(long index) {
	if(!m_hVar)	return false;

	return theAPI.list_DelItemI(m_hVar, index);
}
bool CzList::DelItem(LPCSTR lpVarName) {
	if(!m_hVar)	return false;

	return theAPI.list_DelItemA(m_hVar, lpVarName);
}
bool CzList::DelAll() {
	if(!m_hVar)	return false;

	return theAPI.list_DelAll(m_hVar);
}

bool CzList::GetItemValue(LPCSTR lpItemName, long VarID, void* pValue) {
	if(!m_hVar)	return false;

	ZVAR hVar;
	if(!(hVar = theAPI.list_GetItemA(m_hVar, lpItemName)))
		return false;

	return theAPI.var_GetValueEx(hVar, VarID, pValue);

}
bool CzList::GetItemValue(long index, long VarID, void* pValue) {
	if(!m_hVar)	return false;

	ZVAR hVar;
	if(!(hVar = theAPI.list_GetItemI(m_hVar, index)))
		return false;

	return theAPI.var_GetValueEx(hVar, VarID, pValue);
}
bool CzList::SetItemValue(LPCSTR lpItemName, long VarID, void* pValue) {
	if(!m_hVar)	return false;

	ZVAR hVar;
	if(!(hVar = theAPI.list_GetItemA(m_hVar, lpItemName))) {
		if(!(hVar = theAPI.list_CreateItem(m_hVar, VarID, lpItemName)))
			return false;
	}

	return theAPI.var_SetValueEx(hVar, VarID, pValue);
}
bool CzList::SetItemValue(long index, long VarID, void* pValue) {
	if(!m_hVar)	return false;

	ZVAR hVar;
	if(!(hVar = theAPI.list_GetItemI(m_hVar, index)))
		return false;

	return theAPI.var_SetValueEx(hVar, VarID, pValue);
}

LPCSTR CzList::GetItemName(int index) {
	if(!m_hVar)	return NULL;

	ZVAR hVar;
	if(!(hVar = theAPI.list_GetItemI(m_hVar, index)))
		return NULL;

	return theAPI.var_GetName(hVar);
}